/*
 * Copyright (c) 2022 Firebuild Inc.
 * All rights reserved.
 * Free for personal use and commercial trial.
 * Non-trial commercial use requires licenses available from https://firebuild.com.
 */

/*
 * Test for forking orphan children.
 */
#include <time.h>
#include <unistd.h>


int main() {
  /* Test not waiting, but orphaning a zombie child that quits early. */
  if (fork() > 0) {
    usleep(100*1000);
  } else {
    return 0;
  }

  /* Test not waiting, but orphaning a child that quits later. */
  if (fork() == 0) {
    usleep(100*1000);
    return 0;
  }

  /* Test forking an orphan that quits almost the same time as the parent. */
  fork();
  return 0;
}
